<?xml version="1.0"?>
<!--
Copyright (c) 2022, Hiroyuki Okada
All rights reserved.
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
 * Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
 * Neither the name of Toyota Motor Corporation nor the names of its
   contributors may be used to endorse or promote products derived from
   this software without specific prior written permission.
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
-->
<launch>
	<!-- WHILL Model CR + Hokuyo Top-URG + USB Camera-->
	<include file="$(find ros_whill)/launch/ros_whill.launch"/>	# WHILL Inc.

	<!-- チェックシークエンス -->


	<!-- ジョイスティック -->
	<include file="$(find whill_teleop)/launch/teleop.launch"/> 

	<!-- Hokuyo Top-URG -->
	<node name="urg_node" pkg="urg_node" type="urg_node" output="screen">	
    	<param name="ip_address" value=""/>
  		<param name="serial_port" value="/dev/ttyACM0"/>
    	<param name="serial_baud" value="115200"/>
    	<param name="frame_id" value="laser"/>
    	<param name="calibrate_time" value="true"/>
    	<param name="publish_intensity" value="false"/>
    	<param name="publish_multiecho" value="false"/>
    	<param name="angle_min" value="-1.5707963"/> 
    	<param name="angle_max" value="1.5707963"/> 
	</node>

	<!-- USB Camera -->
	<node name="usb_cam" pkg="usb_cam" type="usb_cam_node" output="screen">
       	<param name="video_device" value="/dev/video0"/>
       	<param name="image_width" value="640"/>
       	<param name="image_height" value="480"/>
       	<param name="pixel_format" value="yuyv"/>
       	<param name="framerate" value="30"/>
       	<param name="contrast" value="32"/>
       	<param name="brightness" value="32"/>
       	<param name="saturation" value="32"/>
       	<param name="autofocus" value="true"/>
       	<param name="focus" value="51"/>
		<param name="camera_info_url" value="file://$(find whill_bringup/config/head_camera.yaml)"/>	
    </node>

	<!-- TF -->
	<node pkg="tf" type="static_transform_publisher" name="baselink_to_vlp201" args="0.75 0 1.0 0 0 0 base_link vlp201 100" />
	<node pkg="tf" type="static_transform_publisher" name="baselink_to_scan" args="0.75 0 0.05 0 0 0 base_link scan 100" />
    <node pkg="tf" type="static_transform_publisher" name="world_to_map" args="0 0 0 0 0 0 world map 100"/>
    <node pkg="tf" type="static_transform_publisher" name="map_to_odom" args="0 0 0 0 0 0 map odom 100"/>
    <node pkg="tf" type="static_transform_publisher" name="baselink_to_laserlink" args="0.75 0 0.05 0 0 0 base_link laser 100" />
    <node pkg="tf" type="static_transform_publisher" name="baselink_to_cameralink" args="0 0 1 0 0 0 base_link head_camera 100" />

	<!-- Debug --> 
	<node name="rviz" pkg="rviz" type="rviz" args="-d $(find whill_bringup)/rviz/whill-urg.rviz" />

</launch>
